#!/usr/bin/perl

# E.T  01

# Run E with various useful strategies


use strict;

my $MROOT = "/home/mptp/gr/E.T.0.1distro";
$MROOT = $ENV{"MLAR_ROOT"} if(exists($ENV{"MLAR_ROOT"}));
my $MBIN = "$MROOT/bin";
# my $MSCRIPT = "$MROOT/script";
my $MTMP = "$MROOT/tmp";

sub mywarn { print @_; }
sub min { my ($x,$y) = @_; ($x <= $y)? $x : $y }
sub max { my ($x,$y) = @_; ($x <= $y)? $y : $x }
sub dprint { print @_; }

my $gtimelimit = $ARGV[0];

my $filestem = $ARGV[$#ARGV];

my $gaxnr = `grep -c '^ *tff' $filestem`;

`cp $filestem $MTMP/$filestem`;

if($gaxnr > 150)
{

`$MBIN/tptp4X -c -u machine $filestem > $MTMP/$filestem.reg0`;

my %h=();
my %t=();
my $conjnm="";
open(F,"$MTMP/$filestem.reg0") or die;
open(F1,">$MTMP/$filestem.reg") or die;
open(F2,">$MTMP/$filestem.types") or die;
while(<F>)
{
    if(m/^ *tff\( *([^, ]+) *, *([^, ]+) *,(.*)/)
    {
	$h{$1}=$_;
	$conjnm = $1 if($2 eq 'conjecture');
	if($2 eq 'type')
	{
	    $t{$1} = $_;
	    print F2 $_;
	}
	else { print F1 $_}
    }
}
close(F);
close(F1);
close(F2);

`$MBIN/features_tff -const -trm0 -sub0 -pat 2 -gen $MTMP/$filestem.reg  > $MTMP/$filestem.trmnrm`;

`cut -f1 -d\: $MTMP/$filestem.trmnrm > $MTMP/$filestem.seq`;

`perl -pe 's/:.*/:/' $MTMP/$filestem.trmnrm > $MTMP/$filestem.deps`;

open(F,">$MTMP/$filestem.eval") or die; print F $conjnm,"\n"; close F;

`$MBIN/predict $MTMP/$filestem.trmnrm $MTMP/$filestem.deps $MTMP/$filestem.seq -pknn -e$MTMP/$filestem.eval -n8 > $MTMP/$filestem.knn_8`;
`$MBIN/predict $MTMP/$filestem.trmnrm $MTMP/$filestem.deps $MTMP/$filestem.seq -pmepo -e$MTMP/$filestem.eval -n128 > $MTMP/$filestem.mepo_128`;

for my $j  ('mepo_128','knn_8')
{
    `cat $MTMP/$filestem.types > $MTMP/$filestem.$j.in`;
    open(F,"$MTMP/$filestem.$j") or die;
    open(G,">>$MTMP/$filestem.$j.in") or die;
    $_ = <F>;
    m/^(.*):(.*)/ or die;
    my ($c,$r) = ($1,$2);
    my @r = split(/ +/,$r);
    for my $l ($c,@r) {print G $h{$l}}
    close(F); close(G);
}

}
else {    `cat $MTMP/$filestem > $MTMP/$filestem.mepo_128.in`; }

my $j = 'mepo_128';

my $schedule_size = 12;

my $tl = max( 1, int( $gtimelimit/(1+$schedule_size) ));


# TODO: fix the .in
# parallelize: run several processes with different schedules
# 

system("$MBIN/eprover-sched.sh sched1 $tl $MTMP/$filestem.$j.in > $MTMP/sched1.out &");
system("$MBIN/eprover-sched.sh sched2 $tl $MTMP/$filestem.$j.in > $MTMP/sched2.out &");
system("$MBIN/eprover-sched.sh sched3 $tl $MTMP/$filestem > $MTMP/sched3.out &");
system("$MBIN/eprover-sched.sh sched4 $tl $MTMP/$filestem > $MTMP/sched4.out &");

my $tl1 = 0;
while($tl1 <= $gtimelimit)
{
    $tl1++;
    sleep 1;
    my @lines = `grep -l 'SZS status[ :]*Theorem' $MTMP/sched1.out $MTMP/sched2.out $MTMP/sched3.out $MTMP/sched4.out`;
    foreach my $l (@lines)
    {
	if($l=~m/sched\d+/)
	{
	    system("killall eprover-sched.sh");
	    system("killall -9 eprover-sched.sh");
	    chomp;
	    my @proof = `cat $l`;
	    foreach $_ (@proof)
	    {
		s/SZS status[ :]*(GaveUp|Time|Res).*/OLD status $1/;
		print $_;
	    }
	    exit(0);
	}
    }
}

system("killall eprover-sched.sh");
system("killall -9 eprover-sched.sh");

print "# SZS status GaveUp\n";

